Klappen5 = {};

function Klappen5.prerequisitesPresent(specializations)
    return true;
end;

function Klappen5:load(xmlFile)

self.setRotateDirection8= SpecializationUtil.callSpecializationsFunction("setRotateDirection8");  -- setRotation wäre hier irreführend weils die funktion von Giants schon gibt, nimm lieder die hier. Mit dem aufruf registrierst du die funktion.

local rotationPartNodeRotation8= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rotation8#index"));
    if rotationPartNodeRotation8 ~= nil then
        self.Rotation8 = {};
        self.Rotation8.node = rotationPartNodeRotation8;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rotation8#minRot"));
        self.Rotation8.minRot = {};
        self.Rotation8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rotation8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rotation8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rotation8#maxRot"));
        self.Rotation8.maxRot = {};
        self.Rotation8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rotation8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rotation8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rotation8.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rotation8#rotTime"), 2)*1000;
    end;

  self.currentRotationDir8= false; -- die aktuelle richtung der drehung als Boolean(wahrheitswert)
end;

function Klappen5:delete()
end;

function Klappen5:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Klappen5:keyEvent(unicode, sym, modifier, isDown)
       if isDown and sym == Input.KEY_m then
             self:setRotateDirection8(not self.currentRotationDir8); -- tastenevents sollte man als funktion auslagern, um MP-sachen zu vereinfachen. Beim tastendruck wird eben die funktion aufgerufen nur eben mit dem genau anderen wert :D
      end;
      end;
function Klappen5:readStream(streamId, connection)  -- wird Aufgerufen wenn ich selber ein Spiel join
     self:setRotateDirection8(streamReadBool(streamId), true);  -- ich rufe also vom server die aktuelle richtung ab. True ist hier wichtig, weil ich will ja nur an meinem rechner den wert haben, und nich an alle anderen Mitspiele das Event schicken (weil die haben den aktuellen wert ja schon :-)) Das true hier also nie vergessen
end;

function Klappen5:writeStream(streamId, connection)  -- wird am Server aufgerufen wenn ein Spieler joint
    streamWriteBool(streamId, self.currentRotationDir8);   -- Wenn einspieler joint möchte ich ihm die aktuelle rotationsrichtung übertragen
end;

function Klappen5:update(dt)
end;


function Klappen5:updateTick(dt)  -- ist wie Update nur verzögert um performance zu sparen. Prinzipiell sollte alles hier rein, bis auf sachen für die die verzögerung nicht reihct(z.b. tastendruck etz)
	if self.Rotation8 ~= nil then
		local x, y, z = getRotation(self.Rotation8.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Rotation8.maxRot, self.Rotation8.minRot, 3, self.Rotation8.rotTime, dt, not self.currentRotationDir8); -- hier habe ich nur drehen druch currentRotationDir8 ersetzt
		setRotation(self.Rotation8.node, unpack(newRot));
   end;
end;

function Klappen5:setRotateDirection8(newDirection, noEventSend)  -- noEventSend bedeutet , dass wenn die variable den wert true hat kein event an andere mitspieler gesendet werden soll
    RotationEvent5.sendEvent(self, newDirection, noEventSend);	-- wir versuchen das event zu senden. Als parameter übergeben wir die neue rotationDirection, die wir beim tastendruck setzen
    self.currentRotationDir8 = newDirection; -- wir setzen nun lokal die neue Richtung
end;
function Klappen5:draw()
end; 
